    program

    include('svbase.inc'), once
    include('svmapper.inc'), once


  map
     MODULE('API')
       OutputDebugString(*CString),RAW,PASCAL,NAME('OutputDebugStringA')
     END
    DebugOutput(STRING pMessage)
    CreateConnection(), *CConnection
    ShowErrors(*CConnection pConn)
    GetFields(*CConnection pConn)
  end


COMIniter           CCOMIniter                              ! CCOMIniter make sure the API COInitialise is called
MyConnect           &CConnection


    code

    if COMIniter.IsInitialised()
      MyConnect &= CreateConnection()
      if ~(MyConnect &= null)
        GetFields(MyConnect)
        MyConnect.Close()
        dispose(MyConnect)
      end
    end


CreateConnection    procedure

szConnectStr        cstring(128)
MyConnectObject     &CConnection
hr                  HRESULT

    code

!Be sure to put in a valid password and user ID !
    szConnectStr = 'Provider=OraOLEDB.Oracle;User ID=xxxx;Password=xxxx;Data Source=Localdb'

    MyConnectObject &= new(CConnection)                     ! Create an instance of a CConnection object
    if ~(MyConnectObject &= null)                           ! If instance was created without error
      hr = MyConnectObject.Init()                           ! Call the init method, this will actually create the ADO Connection object
      if hr = S_OK                                          ! If the ADO connection object was created without error
        hr = MyConnectObject.Connect(szConnectStr)          ! Call the Connect method with the Connection string
        if hr = S_OK                                        ! If method returned S_OK, the object connected to the db
          ! We are connected
          message('Connection made with the db!')
          return MyConnectObject                            ! Object and connection ok, return it
        else
          ! Something whent wrong                           
          message('Connection Object did not return S_OK, not connected to the db')
          ShowErrors(MyConnectObject)
          dispose(MyConnectObject)
          return null
        end
      end

      dispose(MyConnectObject)

    else
      ! Instance creation went wrong
      message('MyConnectObject &= new(CConnection) did fail!')
      return null
    end



ShowErrors      procedure(*CConnection pConn)

Errors          &CErrors
cErr            &CError
lErr            long
cstrDesc        &CStr

ErrorCount      long
ndx             long
hr              HRESULT

ErrorQueue      queue
ErrorID           long
ErrorDesc         string(255)
                end

Window WINDOW('Errors list'),AT(,,401,235),GRAY,DOUBLE
       LIST,AT(3,6,395,190),USE(?List1),HVSCROLL,FORMAT('73R(2)|M~Error Number~@n-15@100L(2)|M~Description~@s255@'), |
           FROM(ErrorQueue)
       BUTTON('Close'),AT(349,206,45,14),USE(?btnClose)
     END

    code

    Errors &= pConn.Errors(hr)                                  ! Get the Errors collection object from the connection

    if hr = S_OK                                                ! if everything ok
      hr = Errors.GetCount(ErrorCount)                          ! Get the count number of errors
      if hr = S_OK                                              !
        loop ndx = 0 to ErrorCount - 1                          ! Single error object in the collection are numbered starting with 0
          cErr &= Errors.Error(ndx, hr)                         ! Get a single error object from the erros collection
          if hr = S_OK                                          !
            hr = cErr.Number(lErr)                              ! Get the error number code
            if hr = S_OK                                        !
              ErrorQueue.ErrorID = lErr                         !
              cstrDesc &= cErr.Description(hr)                  ! Get the description
              if hr = S_OK                                      !
                ErrorQueue.ErrorDesc = cstrDesc.GetCstr()       !
                add(ErrorQueue)                                 ! Add to the list queue
              end
              dispose(cstrDesc)
            end
            dispose(cErr)
          end

        end
      end

      dispose(Errors)

    end

    open(window)
    accept
      case field()
      of ?btnClose
        if event() = EVENT:Accepted
          post(EVENT:CloseWindow)
        end
      end
    end

    free(ErrorQueue)


GetFields       procedure(*CConnection pConn)

FieldQ       queue
Name          string(50)
                end

CustSet         &CRecordset
locCommand      &CCommand
hr              HRESULT
lrecs           LONG

!Be sure to setup the proper table and schema here.
cstrQuery       cstring('SELECT * FROM wsoe.CUSTOMER where 0=1')

Window WINDOW('Fields in table'),AT(,,434,184),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:ANSI),GRAY, |
         DOUBLE
       LIST,AT(9,6,416,128),USE(?List1),VSCROLL,FORMAT('48L(2)|M~Field Name~@s50@'),FROM(FieldQ)
       BUTTON('Close'),AT(361,150,45,14),USE(?Close)
     END


    code
!
      locCommand &= new(CCommand)
      hr = locCommand.Init()
      hr = locCommand.PutRefActiveConnection(pConn)
      HR = locCommand.PutCommandType(adCmdText)
      HR = locCommand.PutCommandTimeout(4)
!
      hr = locCommand.PutCommandText(cstrQuery)
!
      CustSet &= locCommand._Execute(, hr)

      if hr = S_OK                                                                      ! If no errors
        DO GetFieldsFromSet
      else
        ShowErrors(pConn)
      end
!    end

    if records(FieldQ)                        ! If there are records, open the window and display them

      open(window)
      accept
        case field()
        of ?Close
          if event() = EVENT:Accepted
            post(EVENT:CloseWindow)
          end
        end
      end

    end

    free(FieldQ)                             ! Free the queue
    CustSet.Close()                             ! Close the set
    dispose(CustSet)                            ! Cleanup memory
!
    dispose(locCommand)

GetFieldsFromSet ROUTINE
 DATA
Flds            &CFields
Fld             &CField
hr              HRESULT
dwCount         long
iCol            long
lType           LONG
CSTRCPtr        &CStr
NameCPtr        &CSTRING
 CODE
    Flds &= CustSet.GetFields(hr)
    if hr = S_OK
      hr = Flds.GetCount(dwCount)
      if hr = S_OK
        loop iCol = 0 to dwCount - 1
          Fld &= Flds.GetField(iCol, hr)
          if hr = S_OK
            CSTRCPtr &= Fld.GetName( hr )
            if hr = S_OK
              NameCPtr &= CSTRCPtr.GetCStr()
              FieldQ.Name = NameCPtr
              CSTRCPtr.Release()
              DISPOSE(CSTRCPtr)
              ADD(FieldQ)
            end
            dispose(Fld)
          end
        end
      end
      dispose(Flds)
    end



DebugOutput PROCEDURE(STRING pMessage)
lCstring CSTRING(512)
 CODE
 lCstring = pMessage
 OutputDebugString(lCstring)

